/*
*********************************************************************************************************
*                                                uC/OS
*                                        The Real-Time Kernel
*
*                       (c) Copyright 1992, 1993, Jean J. Labrosse, Plantation, FL
*                                          All Rights Reserved
*
*                                          X32 Specific code
*
* File : Ix86S.H
* By   : Jean J. Labrosse
*********************************************************************************************************
*/

#ifndef _IX86S
#define _IX86S

#include <x32.h>

/*
*********************************************************************************************************
*                                              DATA TYPES
*********************************************************************************************************
*/

typedef unsigned char  BOOLEAN;
typedef unsigned char  UBYTE;                    /* Unsigned  8 bit quantity                           */
typedef signed   char  BYTE;                     /* Signed    8 bit quantity                           */
typedef unsigned int   UWORD;                    /* Unsigned 16 bit quantity                           */
typedef signed   int   WORD;                     /* Signed   16 bit quantity                           */
typedef unsigned long  ULONG;                    /* Unsigned 32 bit quantity                           */
typedef signed   long  LONG;                     /* Signed   32 bit quantity                           */
typedef float          FP;                       /* Single precision floating point                    */

/*
*********************************************************************************************************
*                                              CONSTANTS
*********************************************************************************************************
*/

#ifndef  FALSE
#define  FALSE    0
#endif

#ifndef  TRUE
#define  TRUE     1
#endif

/*
*********************************************************************************************************
*                                        X32 Processor Specifics
*********************************************************************************************************
*/

#define  OS_ENTER_CRITICAL()  { DISABLE_INTERRUPT(INTERRUPT_GLOBAL); }
#define  OS_EXIT_CRITICAL()   { if(OSRunning) ENABLE_INTERRUPT(INTERRUPT_GLOBAL); }
#define  OS_TASK_SW()         OSCtxSw();

#define  OS_FAR
#define  OS_STK_TYPE          UBYTE


#endif
