#include <x32.h>
#include <ucos.h>

#define TASK_PRIORITY_READ 11
#define TASK_PRIORITY_CONTROL 12
#define STK_SIZE 1024

static unsigned int ReadStk[STK_SIZE];
static unsigned int ControlStk[STK_SIZE];

void vRead(void *data) {                       
    while (TRUE) {
        printf("%d ", (int)data);                   

        OSTimeDly(4);                           

    } 
}

void vControl(void *data) {
    while (TRUE) {
        printf("%d ", (int)data);

        OSTimeDly(2);

    }  

}  

void isr_buttons() {
    if(peripherals[PERIPHERAL_BUTTONS] & 8)
        exit();

}

int main() {
    SET_INTERRUPT_VECTOR(INTERRUPT_BUTTONS, &isr_buttons);
    SET_INTERRUPT_PRIORITY(INTERRUPT_BUTTONS, 30); 
    ENABLE_INTERRUPT(INTERRUPT_BUTTONS); 

    OSInit();

    OSTaskCreate(vRead, (void *)1, (void *)ReadStk, TASK_PRIORITY_READ);
    OSTaskCreate(vControl, (void *)2, (void *)ControlStk, TASK_PRIORITY_CONTROL);

    OSStart();     

    return 0;

}

